.686p    
.model flat,stdcall
option casemap:none
.xmm
.mmx
WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
CreateControls  PROTO   :DWORD
CreateImageList PROTO   
CreateTreeView  PROTO   :DWORD
CreateListView  PROTO   :DWORD


include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc
include \masm32\include\msimg32.inc
include \masm32\include\shell32.inc
include \masm32\include\objbase.inc
include \masm32\include\user.inc
;include \masm32\include\ole32.inc
include \masm32\include\oleaut32.inc
include \masm32\rar\unrar.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\msimg32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\rar\unrar.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

NoTBButtons         equ     3
NoTBImages          equ     2
TBId                equ     100
RBId                equ     200

CtrlSpacing         equ     74
TVS_USER            equ     WS_CHILD+WS_VISIBLE+TVS_HASLINES+TVS_HASBUTTONS+TVS_LINESATROOT
LVS_USER            equ     WS_CHILD+WS_VISIBLE+LVS_REPORT

.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      'RAR LockSmith',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>
szAppName       db      'RAR LockSmith',0

; +++ Graphics related ++++

szRARBitmap     db      '.\rar.bmp',0
hBmpRAR         HBITMAP     ?
rect            RECT        <>
ps      	PAINTSTRUCT     <>
hMemDC          HDC         ?
Facename        db      'Impact',0
hFont           HFONT       ?
hIml            dd          ?

; ++++ ReBar related ++++

ReBarClass      db          'ReBarWindow32',0
hReBar          HWND            ?
rbbi            REBARBANDINFO   <sizeof rbbi,<>>
; ++++ Toolbar related ++++

ToolbarClass    db          'ToolbarWindow32',0
hToolbar        HWND            ?
TBButtons       TBBUTTON        <0,0,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                TBBUTTON        <1,0,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                TBBUTTON        <2,0,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>

; ++++ TreeView related ++++

TreeViewClass       db      'SysTreeView32',0
hTreeView           HWND        ?
tvis            TV_INSERTSTRUCT     <>

DirLocationRef      dd      CSIDL_PERSONAL
                    db      'Desktop',0
                    dd      CSIDL_PERSONAL
                    db      'My Documents',0
                    dd      CSIDL_DRIVES
                    db      'My Computer',0
FirstTimeUse        dd      TRUE
shfi            SHFILEINFO      <>
DirPath             db      256 dup(0)
strret              STRRET      <>
lpIDL               dd          ?
                    
; ++++ ListView related ++++

ListViewClass       db      'SysListView32',0
hListView           HWND        ?
lvi                 LV_ITEM     <>
lvc                 LV_COLUMN   <>
szFileName          db      'FileName',0
szPackSize          db      'Pack size',0
szUnPackSize        db      'Unpack Size',0
szStorageType       db      'Storage Type',0
szDictionarySize    db      'Dictionary Size',0
ppvIShellFolder     dd          ?

.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  CoInitialize,NULL
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
	.elseif	uMsg==WM_CREATE
		mov		edi,lParam
		.if	[edi.CREATESTRUCT].hWndParent==NULL
                invoke  CreateControls,hWnd
                invoke  GetClientRect,hWnd,addr rect
                invoke  InvalidateRect,hWnd,addr rect,NULL
		.endif	        	
    .elseif     uMsg==WM_PAINT
        invoke  BeginPaint,hWnd,addr ps
        invoke  CreateCompatibleDC,ps.hdc
        mov     hMemDC,eax
        invoke  LoadImage,hInstance,addr szRARBitmap,IMAGE_BITMAP,NULL,NULL,LR_LOADFROMFILE+LR_DEFAULTSIZE+LR_LOADTRANSPARENT
        mov     hBmpRAR,eax
        invoke  SelectObject,hMemDC,hBmpRAR
        invoke  DeleteObject,eax
        invoke  BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ps.rcPaint.right,ps.rcPaint.bottom,\
                    hMemDC,0,0,SRCAND
        invoke  DeleteObject,hBmpRAR
        invoke  CreateFont,36,32,0,0,FW_HEAVY,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,\
                            DEFAULT_QUALITY,DEFAULT_PITCH+FF_ROMAN,addr Facename
        mov     hFont,eax
        invoke  SelectObject,ps.hdc,hFont
        invoke  DeleteObject,eax
        invoke  SetBkMode,ps.hdc,TRANSPARENT
        invoke  SetTextColor,ps.hdc,0800000h
        invoke  TextOut,ps.hdc,50,0,addr szAppName,sizeof szAppName                            
        invoke  DeleteObject,hFont
        invoke  EndPaint,hWnd,addr ps
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

CreateControls  PROC    hWnd:DWORD

        invoke  GetClientRect,hWnd,addr rect
        invoke  CreateWindowEx,NULL,addr ReBarClass,NULL,WS_VISIBLE+WS_CHILD+RBS_AUTOSIZE+CCS_NOPARENTALIGN,\
                    0,30,rect.right,CW_USEDEFAULT,hWnd,RBId,hInstance,NULL  
        mov     hReBar,eax
        invoke  CreateWindowEx,NULL,addr ToolbarClass,NULL,WS_VISIBLE+WS_CHILD+TBSTYLE_FLAT,\
                    0,0,CW_USEDEFAULT,CW_USEDEFAULT,hWnd,TBId,hInstance,NULL
        mov     hToolbar,eax
        invoke  CreateImageList
        invoke  SendMessage,hToolbar,TB_SETIMAGELIST,0,hIml
        invoke  SendMessage,hToolbar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
        invoke  SendMessage,hToolbar,TB_ADDBUTTONS,NoTBButtons,addr TBButtons
        mov     rbbi.cbSize,sizeof rbbi
        mov     rbbi.fMask,RBBIM_CHILD+RBBIM_SIZE+RBBIM_CHILDSIZE+RBBIM_STYLE
        mov     rbbi.fStyle,RBBS_GRIPPERALWAYS
        push    hToolbar
        pop     rbbi.hwndChild
        mov     rbbi.lx,200
        mov     rbbi.cyMinChild,34
        mov     rbbi.cxMinChild,100
        mov     rbbi.cyMaxChild,34
        invoke  SendMessage,hReBar,RB_INSERTBAND,-1,addr rbbi
        invoke  CreateTreeView,hWnd
        invoke  CreateListView,hWnd
        ret

CreateControls  endp

CreateImageList PROC

        local   hBmp:DWORD,hBmpMask:DWORD
        
        invoke  ImageList_Create,24,24,ILC_COLOR+ILC_MASK,3,3
        mov     hIml,eax
        mov     ecx,NoTBImages
        mov     edi,100
img_loop:        
        push    ecx            
    ;    invoke  LoadBitmap,hInstance,edi
        invoke  LoadImage,hInstance,edi,IMAGE_BITMAP,24,24,NULL
        mov     hBmp,eax
        inc     edi
;        invoke  LoadBitmap,hInstance,edi
        invoke  LoadImage,hInstance,edi,IMAGE_BITMAP,24,24,NULL
        mov     hBmpMask,eax
        inc     edi
        invoke  ImageList_Add,hIml,hBmp,eax
        invoke  DeleteObject,hBmp
        invoke  DeleteObject,hBmpMask
        pop     ecx
        dec     ecx
        jcxz    end_img_loop
        jmp     img_loop
end_img_loop:
        ret

CreateImageList endp        

CreateTreeView      PROC    hWnd:DWORD

        invoke  SHGetDesktopFolder,addr ppvIShellFolder
        invoke  GetClientRect,hWnd,addr rect
        mov     rect.top,CtrlSpacing
        sub     rect.bottom,CtrlSpacing
        shr     rect.right,2
        dec     rect.right
        invoke  CreateWindowEx,NULL,addr TreeViewClass,NULL,TVS_USER,\
                    rect.left,rect.top,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
        mov     hTreeView,eax
        mov     ecx,3
        lea     esi,DirLocationRef
        mov     tvis.hParent,NULL
        mov     tvis.hInsertAfter,TVI_ROOT
        mov     tvis.item.imask,TVIF_TEXT+TVIF_IMAGE+TVIF_PARAM
        mov     FirstTimeUse,TRUE
insertion_loop:
        push    ecx
        push    dword ptr [esi]
        pop     tvis.item.lParam
        invoke  SHGetSpecialFolderLocation,hWnd,[esi],addr lpIDL
        .if eax!=NOERROR
            invoke  Beep,200,20
        .endif            
        mov     strret.uType,STRRET_WSTR
        push    offset strret
        push    SHGDN_NORMAL
        push    lpIDL
        push    offset [ppvIShellFolder.IShellFolder].GetDisplayNameOf
;        call    dword ptr [ppvIShellFolder.IShellFolder];,lpIDL,SHGDN_NORMAL,addr strret
        add     esp,16
        invoke  SHGetFileInfo,addr DirPath,0,addr shfi,sizeof shfi,SHGFI_SYSICONINDEX+SHGFI_SMALLICON
        .if     FirstTimeUse==TRUE
            invoke  SendMessage,hTreeView,TVM_SETIMAGELIST,TVSIL_NORMAL,eax
            mov     FirstTimeUse,FALSE
        .endif
        add     esi,4
        mov     tvis.item.pszText,esi
        push    shfi.iIcon
        pop     tvis.item.iImage                    
        invoke  SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
        pop     ecx
        dec     ecx
        jcxz    end_insertion_loop
realign_loop:
        lodsb
        cmp     al,0
        jne     realign_loop
        jmp     insertion_loop
end_insertion_loop:
        
        ret

CreateTreeView      endp

CreateListView      PROC    hWnd:DWORD

        invoke  GetClientRect,hWnd,addr rect
        push    rect.right
        mov     rect.top,CtrlSpacing
        sub     rect.bottom,CtrlSpacing
        mov     eax,rect.right
        shr     eax,2
        add     eax,1
        mov     rect.left,eax
        sub     rect.right,eax
        invoke  CreateWindowEx,NULL,addr ListViewClass,NULL,LVS_USER,\
                    rect.left,rect.top,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
        mov     hListView,eax
        pop     rect.right
        mov     eax,rect.right
        shr     eax,2
        sub     rect.right,eax
        mov     eax,rect.right
        shr     eax,2
        sub     rect.right,eax
        mov     lvc.lx,eax
        mov     lvc.imask,LVCF_TEXT+LVCF_WIDTH
        mov     lvc.pszText,offset szFileName
        invoke  SendMessage,hListView,LVM_INSERTCOLUMN,0,addr lvc
        shr     rect.right,2
        push    rect.right
        pop     lvc.lx
        mov     lvc.pszText,offset szPackSize
        invoke  SendMessage,hListView,LVM_INSERTCOLUMN,1,addr lvc
        mov     lvc.pszText,offset szUnPackSize
        invoke  SendMessage,hListView,LVM_INSERTCOLUMN,2,addr lvc
        mov     lvc.pszText,offset szStorageType
        invoke  SendMessage,hListView,LVM_INSERTCOLUMN,3,addr lvc
        mov     lvc.pszText,offset szDictionarySize
        dec     lvc.lx
        invoke  SendMessage,hListView,LVM_INSERTCOLUMN,4,addr lvc
        ret

CreateListView      endp                                                                    

end	start